<?php

include_once(realpath(dirname(__FILE__)) . "/Prodvirtuel.class.php");

class AdminProdvirtuel extends Prodvirtuel {

	public $fichier_existe = false;

	public $objproduit;

	public function __construct($refproduit = false) {

		parent::__construct();

		$this->objproduit = new Produit();

		if ($refproduit) $this->objproduit->charger($refproduit);
	}

	public function supprimer($id_pv) {

		if ($this->charger($id_pv)) {
			@unlink($this->get_chemin_fic_virtuel());

			$this->delete();
		}
	}

	public function ajouter($nom, $nom_tmp) {

		$erreur = false;

		if (preg_match("/([^\/]*)\.(.*)$/i", $nom, $decoupe)) {

			$fich = eregfic($decoupe[1]);
			$ext = $decoupe[2];

			if ($fich != "" && $ext != "") {

				$code = gencode(10);

				$nom_code = $fich . '_' . $code . "." . $ext;

				$this->produit = $this->objproduit->id;
				$this->nom = $fich . "." . $ext;
				$this->fichier = $nom_code;

				if (! move_uploaded_file($nom_tmp, $this->get_chemin_fic_virtuel())) {
					$erreur = "Erreur à la mise en place du fichier \"".$this->get_chemin_fic_virtuel()."\"";
				} else {
					$this->add();
				}

			} else {
				$erreur = "Fichier \"$nom\" refusé: le nom et/ou l'extension ne peuvent être vides.";
			}
		}
		else {
			$erreur = "Fichier \"$nom\" refusé: impossible de distinguer l'extension du nom de fichier";
		}

		return $erreur;
	}

	public function lister_par_commande($idcommande) {

		$produits = array();

		$resul = $this->query("select * from ".Prodvirtuel_commande::TABLE." where commande=$idcommande");

		while($resul && $row = $this->fetch_object($resul)) {

			$pv = new Prodvirtuel();

			if ($pv->charger($row->prodvirtuel)) {

				$proddesc = new Produitdesc();

				if ($proddesc->charger($pv->produit)) {

					$produits[] = array(
						'prodtitre' => $proddesc->titre,
						'prodvirtuel' => $pv
					);
				}
			}
		}

		return $produits;
	}

	public function liste_fichiers_produit() {
		return parent::liste_fichiers_produit($this->objproduit->id);
	}

	public function prepare_page() {
		//rien...
	}
}
?>