<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/divers.php");

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produitdesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Raisondesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Paysdesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Zone.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Transzone.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Modules.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Mail.class.php");

include_once(realpath(dirname(__FILE__)) . "/Prodvirtuel_commande.class.php");

class Prodvirtuel extends PluginsTransports {

	const MODULE = "prodvirtuel";

	public $id;
	public $produit;
	public $nom;
	public $fichier;

	const TABLE = "prodvirtuel";

	public $table = self::TABLE;

	public $bddvars = array("id", "produit", "nom", "fichier");

	function __construct($id = "") {

		parent::__construct(self::MODULE);

		if ($id != "") $this->charger($id);
	}

	public function init(){

		$this->ajout_desc("Téléchargement", "Téléchargement", "", 1);

		$variable = new Variable();

		if ($variable->charger("repvirtuel")) {
			$nomrep = realpath("../client")."/$variable->valeur";
		} else {
			$code = gencode(30);

			$nomrep = realpath("../client")."/$code";

			$variable->nom = "repvirtuel";
			$variable->valeur = $code;
			$variable->protege = 1;
			$variable->add();
		}

		if (! is_dir($nomrep) && ! @mkdir($nomrep, 0755)) {
			die("Impossible de créer le répertoire $nomrep. Vérifiez les droits d'accès et recommencez.");
		}

		$mod = new Modules();
		$mod->charger(self::MODULE);

		$zone = new Zone();
		$resul = $zone->query("select * from $zone->table");

		while($resul && $row = $this->fetch_object($resul)) {
			$transzone = new Transzone();
			$transzone->transport = $mod->id;
			$transzone->zone = $row->id;
			$transzone->add();
		}

		$query_prodvirtuel =
			"CREATE TABLE IF NOT EXISTS `$this->table` (
			 `id` INT NOT NULL auto_increment,
			 `produit` INT NOT NULL ,
		 	 `nom` text NOT NULL,
		  	 `fichier` text NOT NULL,
			PRIMARY KEY (  `id` )
			) AUTO_INCREMENT=1 ;";

		$this->query($query_prodvirtuel);

		$pvc = new Prodvirtuel_commande();

		$pvc->init();

		$message = new Message();

		if (! $message->charger("mailprodvirtuel")) {

			$message->nom = "mailprodvirtuel";
			$lastid = $message->add();

			$messagedesc = new Messagedesc();
			$messagedesc->message = $lastid;

			$messagedesc->lang = 1;
			$messagedesc->intitule = "Téléchargement d'un fichier virtuel";
			$messagedesc->titre    = "Votre fichier commandé sur __NOMSITE__";

			$messagedesc->chapo = "";

			$messagedesc->description =
				  "__CLIENT_FACTPRENOM__ __CLIENT_FACTNOM__<br />"
				. "__CLIENT_ADRESSE1__ __CLIENT_ADRESSE2__ __CLIENT_ADRESSE3__<br />"
				. "__CLIENT_CPOSTAL__ __CLIENT_VILLE__<br />__CLIENT_PAYS__<br /><br />"
				. "Téléchargement des fichiers de la commande __COMMANDE_REF__ du __COMMANDE_DATE__<br /><br />"
				. "Les articles commandés:<br />"
				. "<VENTEPROD><br />"
				. "<a href=\"__VENTEPROD_TELECHARGER__\"> __VENTEPROD_TITRE__ / __VENTEPROD_FICHIER__</a> ( __VENTEPROD_TELECHARGER__ )<br />"
				. "</VENTEPROD>";

			$messagedesc->descriptiontext =
				  "__CLIENT_FACTPRENOM__ __CLIENT_FACTNOM__\n"
				. "__CLIENT_ADRESSE1__ __CLIENT_ADRESSE2__ __CLIENT_ADRESSE3__\n"
				. "__CLIENT_CPOSTAL__ __CLIENT_VILLE__\n__CLIENT_PAYS__\n\n"
				. "Téléchargement des fichiers de la commande __COMMANDE_REF__ du __COMMANDE_DATE__\n\n"
				. "Les articles commandés:\n"
				. "<VENTEPROD>\n"
				. "Article : __VENTEPROD_TITRE__ / __VENTEPROD_FICHIER__ : __VENTEPROD_TELECHARGER__\n"
				. "</VENTEPROD>";

			$messagedesc->add();
		}
	}

	public function destroy() {

		$pvc = new Prodvirtuel_commande();
		$pvc->destroy();

		$mod = new Modules();
		$mod->charger(self::MODULE);

		$this->query("delete from " . Transzone::TABLE . " where transport = $mod->id");
	}

	public function charger($id){
		return $this->getVars("select * from $this->table where id=\"$id\"");
	}

	public function liste_fichiers_produit($produit){

		$liste = array();

		$res = $this->query("select * from $this->table where produit=\"$produit\"");

		while ($res && $row = $this->fetch_object($res, 'Prodvirtuel')) {
			$liste[] = $row;
		}

		return $liste;
	}

	public function est_produit_virtuel($produit){
		$res = $this->query("select count(*) from $this->table where produit=\"$produit\"");

		return $res && ($this->get_result($res) > 0);
	}

	public function calcule() {
		return 0;
	}

	public function action() {

		if($_REQUEST['action'] == "prodvirtueldl") {

			$idproduit = false;

			if (isset($_REQUEST['token']) &&  $_REQUEST['token'] != "") {

				$prodcmd = new Prodvirtuel_commande();

				if ($prodcmd->charger($_REQUEST['token'])) {

					$virt = new Prodvirtuel();

					if ($virt->charger($prodcmd->prodvirtuel)) {

						$filepath = $virt->get_chemin_fic_virtuel();

						header('Content-type: application/force-download; name="' . $virt->nom . '"');
						header("Content-Transfer-Encoding: binary");
						header("Content-Length: ".filesize($filepath));
						header('Content-Disposition: attachment; filename="' . $virt->nom . '"');
						header("Expires: 0");
						header("Cache-Control: no-cache, must-revalidate");
						header("Pragma: no-cache");

						readfile($filepath);

						exit;
					}
				}
			}
		}

	}

	public function boucle($texte, $args)
	{
		$boucle = strtolower(lireTag($args, 'boucle'));

		switch($boucle)
		{
			case 'commande':
				return $this->boucleCommande($texte, $args);
				break;

			case 'produit':
				return $this->boucleProduit($texte, $args);
				break;

			case 'transport':
				return $this->boucleTransport($texte, $args);
				break;
		}
	}

	/*
	 * Afficher le fichier uniquement si le produit demandé est gratuit
	 */
	private function boucleProduit($texte, $args) {

		$idproduit = intval(lireTag($args, 'produit'));

		$resul = $this->query("select * from $this->table where produit=$idproduit");

		while ($resul && $row = $this->fetch_object($resul, "Prodvirtuel")) {

			$prod = new Produit();

			if ($prod->charger_id($idproduit)) {

				$tmp = $texte;

				$tmp = str_replace("#NOM", $row->nom, $tmp);
				$tmp = str_replace("#FICHIER", $row->fichier, $tmp);
				$tmp = str_replace("#URL", $row->get_url_download('produit', $idproduit), $tmp);

				$res .= $tmp;
			}
		}

		return $res;
	}

	private function boucleCommande($texte, $args) {

		$idcommande = intval(lireTag($args, 'commande'));
		$idproduit  = intval(lireTag($args, 'produit'));
		$refproduit = lireTag($args, 'refproduit');

		if (intval($idproduit) == 0) {

			if ($refproduit != '') {
				$prod = new Produit($refproduit);

				$idproduit = intval($prod->id);
			}
		}

		$resul = $this->query("select * from ".Prodvirtuel_commande::TABLE." where commande=$idcommande");

		while($resul && $row = $this->fetch_object($resul)) {

			$pv = new Prodvirtuel();

			if ($pv->charger($row->prodvirtuel)) {

				if ($idproduit != 0 && $pv->produit != $idproduit) continue;

				$proddesc = new Produitdesc();

				if ($proddesc->charger($pv->produit)) {

					$tmp = $texte;

					$tmp = str_replace("#TITRE", $proddesc->titre, $tmp);
					$tmp = str_replace("#PRODUIT", $pv->produit, $tmp);
					$tmp = str_replace("#NOM", $pv->nom, $tmp);
					$tmp = str_replace("#FICHIER", $pv->fichier, $tmp);
					$tmp = str_replace("#URL", $pv->get_url_download('token', $row->token), $tmp);

					$res .= $tmp;
				}
			}
		}

		return $res;
	}

	private function boucleTransport($texte, $args) {

		// Compter le nombre de produits virtuels & non virtuels
		$nb_virtuels = 0;
		$nb_non_virtuels = 0;

		foreach($_SESSION['navig']->panier->tabarticle as &$art) {

			$pv = new Prodvirtuel();

			if ($pv->est_produit_virtuel($art->produit->id))
				$nb_virtuels++;
			else
				$nb_non_virtuels++;
		}

		// Si on n'a que des produits virtuels, on ne propose que le transport "telecharger"
		if($nb_virtuels > 0 &&  $nb_non_virtuels == 0) {
			return boucleTransport($texte, 'nom="'.self::MODULE.'"');
		} else {
			if (strstr($args, 'exclusion')) {
				$args = preg_replace('/exclusion="([^"]*)"/', ' exclusion="\\1,'.self::MODULE.'"', $args);
			} else {
				$args .= ' exclusion="'.self::MODULE.'"';
			}

			return boucleTransport($texte, $args);
		}
	}

	public function aprescommande($commande){

		foreach($_SESSION['navig']->panier->tabarticle as &$art) {

			$pv = new Prodvirtuel();

			$fics = $pv->liste_fichiers_produit($art->produit->id);

			foreach($fics as $fic) {
				$virtcmd = new Prodvirtuel_commande();
				$virtcmd->prodvirtuel = $fic->id;
				$virtcmd->commande = $commande->id;
				$virtcmd->token = gencode(30);
				$virtcmd->add();
			}
		}
	}

	public function statut($commande) {

		if($commande->statut != "2")
			return;

		$pvcommande = new Prodvirtuel_commande();

		$query = "select count(*) as nb from $pvcommande->table where commande=\"" . $commande->id . "\"";

		$resul = $pvcommande->query($query);

		if ($resul && intval($this->get_result($resul)) != 0) {

			$message = new Message("mailprodvirtuel");
			$msgdesc = new Messagedesc($message->id);

			$emailcontact = new Variable("emailcontact");
			$emailfrom = new Variable("emailfrom");
			$nomsite = new Variable("nomsite");

			$sujet = $this->substitmail($msgdesc->titre, $commande);
			$corps = $this->substitmail($msgdesc->description, $commande);
			$corpstext = $this->substitmail($msgdesc->descriptiontext,$commande);

			$client = new Client($commande->client);

			// Envoi du mail au client
			Mail::envoyer(
				"$client->prenom $client->nom", $client->email,
				$nomsite->valeur, $emailcontact->valeur,
				$sujet,
				$corps, $corpstext);
		}
	}

	public function confirmation($commande){
		$this->statut($commande);
	}

	protected function substitmail($corps, $commande ) {

		$emailcontact = new Variable("emailcontact");
		$emailfrom = new Variable("emailfrom");
		$nomsite = new Variable("nomsite");
		$urlsite = new Variable("urlsite");

		$jour = substr($commande->date, 8, 2);
		$mois = substr($commande->date, 5, 2);
		$annee = substr($commande->date, 0, 4);

		$heure = substr($commande->date, 11, 2);
		$minute = substr($commande->date, 14, 2);
		$seconde = substr($commande->date, 17, 2);

		$client = new Client($commande->client);

		$corps = str_replace("__COMMANDE_REF__", $commande->ref, $corps);
		$corps = str_replace("__COMMANDE_DATE__", $jour . "/" . $mois . "/" . $annee, $corps);

		$corps = str_replace("__NOMSITE__", $nomsite->valeur, $corps);
		$corps = str_replace("__URLSITE__", $urlsite->valeur, $corps);

		$adresse = new Venteadr($commande->adrfact);

		$raisondesc = new Raisondesc();
		$raisondesc->charger($adresse->raison);

		$pays = new Paysdesc();
		$pays->charger($adresse->pays);

		$corps = str_replace("__CLIENT_REF__", $client->ref, $corps);
		$corps = str_replace("__CLIENT_RAISON__",$raisondesc->court, $corps);
		$corps = str_replace("__CLIENT_ENTREPRISE__", $client->entreprise, $corps);
		$corps = str_replace("__CLIENT_SIRET__", $client->siret, $corps);
		$corps = str_replace("__CLIENT_FACTNOM__", $adresse->nom, $corps);
		$corps = str_replace("__CLIENT_FACTPRENOM__", $adresse->prenom, $corps);
		$corps = str_replace("__CLIENT_ADRESSE1__", $adresse->adresse1, $corps);
		$corps = str_replace("__CLIENT_ADRESSE2__", $adresse->adresse2, $corps);
		$corps = str_replace("__CLIENT_ADRESSE3__", $adresse->adresse3, $corps);
		$corps = str_replace("__CLIENT_CPOSTAL__", $adresse->cpostal, $corps);
		$corps = str_replace("__CLIENT_VILLE__", $adresse->ville, $corps);
		$corps = str_replace("__CLIENT_PAYS__", $pays->titre, $corps);
		$corps = str_replace("__CLIENT_EMAIL__", $client->email, $corps);
		$corps = str_replace("__CLIENT_TELFIXE__", $client->telfixe, $corps);
		$corps = str_replace("__CLIENT_TELPORT__", $client->telport, $corps);

		$pattern = '{<VENTEPROD>((?:(?:(?!<VENTEPROD[^>]*>|</VENTEPROD>).)++|<VENTEPROD[^>]*>(?1)</VENTEPROD>)*)</VENTEPROD>}si';

		if (preg_match($pattern, $corps, $cut)) {

			$pvcommande = new Prodvirtuel_commande();

			$resul = $pvcommande->query("select * from $pvcommande->table where commande=$commande->id");

			$res = '';

			while($resul && $row = $this->fetch_object($resul)) {

				$tmpvirt = new Prodvirtuel();
				$tmpvirt->charger($row->prodvirtuel);

				$proddesc = new Produitdesc();
				$proddesc->charger($tmpvirt->produit);

				$temp = $cut[1];

				$temp = str_replace("__VENTEPROD_TITRE__", $proddesc->titre, $temp);
				$temp = str_replace("__VENTEPROD_FICHIER__", $tmpvirt->nom, $temp);
				$temp = str_replace("__VENTEPROD_TELECHARGER__", rtrim($urlsite->valeur, '/') . "/?action=prodvirtueldl&token=" . $row->token, $temp);

				$res .= $temp;
			}

			$corps = str_replace($cut[1], $res, $corps);
		}

		return $corps;
	}

	public function get_chemin_fic_virtuel() {

		$repvirtuel = new Variable("repvirtuel");

		return sprintf("%s/../../%s/%s", realpath(dirname(__FILE__)), $repvirtuel->valeur, $this->fichier);
	}

	public function get_url_fic_virtuel() {

		$urlsite = new Variable("urlsite");
		$repvirtuel = new Variable("repvirtuel");

		return sprintf("%s/client/%s/%s", rtrim($urlsite->valeur, '/') , $repvirtuel->valeur, $this->fichier);
	}

	public function get_url_download($mode, $valeur) {

		$urlsite = new Variable("urlsite");
		$repvirtuel = new Variable("repvirtuel");

		return sprintf("%s/?action=prodvirtueldl&%s=%s", rtrim($urlsite->valeur, '/'), $mode, $valeur);
	}
}
?>